import BP, time

def Apply(Sender):
  isdt = CDte.Checked
  ismd = CMod.Checked
  iswh = CWho.Checked
  isnf = CNfo.Checked
  iscg = CCtg.Checked
  isvl = CVal.Checked
  ismk = CMrk.Checked

  a = BP.AccountCurrent()
  if isdt:
    dt = time.gmtime((int(EDte.Date) - 25569) * 86400)[:3]
    dt = "%.2d-%.2d-%.4d" %(dt[2], dt[1], dt[0])
  if ismd:
    if EMod.ItemIndex < 6: sgn = -1
    else: sgn = 1
    md = EMod.Items[EMod.ItemIndex]
  if iswh: wh = EWho.Text
  if isnf: nf = ENfo.Text
  if iscg: cg = CIndexes[ECtg.ItemIndex - 1]
  
  if isvl:
    try:
      vl = abs(float(EVal.Text.replace(",", ".")))
    except:
      BP.MsgBox("Le montant saisi est incorrect", 64)
      return
  if ismk: mk = EMrk.ItemIndex

  for i in idx:
    if isdt: BP.OperationDate[a][i] = dt
    if ismd and sgn == BP.OperationModeSign[a][i]:
      BP.OperationMode[a][i] = md
    if iswh: BP.Operationthirdparty[a][i] = wh
    if isnf: BP.OperationDetails[a][i] = nf
    if iscg: BP.OperationCateg[a][i] = cg
    if isvl: BP.OperationAmount[a][i] = vl * BP.OperationModeSign[a][i]
    if ismk: BP.OperationMark[a][i] = mk
    
  BP.AccountRefreshScreen()
  f.Close()


cnames = BP.CategName
CTrimNames = []
CPositions = {-1: -1}
CIndexes = {-1: -1}
CNames = []
for i, c in enumerate(cnames):
  p = c.find("=")
  CNames.append(c[p+1:])
  CTrimNames.append(c[p+1:].strip())
  idx = int(c[:p])
  CPositions[idx] = i
  CIndexes[i] = idx
CNames = ["-- Aucune --"] + CNames

modes = [BP.OperationGetNameFromModeIndex(i) for i in range(10)]

l1, l2 = BP.LineSelect(-1), BP.LineSelect(-2)
if l1 > l2: l1, l2 = l2, l1
idx = [i for i in BP.VisibleLines() if i >= l1 and i <= l2]

f = CreateComponent("TForm", None)
f.SetProps(Position="poMainFormCenter", Width=350, Height=360, BorderStyle="bsSingle", BorderIcons=["biSystemMenu","biMinimize"], Caption="Modifier un groupe d'oprations")
CDte = CreateComponent("TCheckBox", f)
CDte.SetProps(Parent=f, Left=30, Top=30, Width=76, Caption="Date :")
CMod = CreateComponent("TCheckBox", f)
CMod.SetProps(Parent=f, Left=30, Top=60, Width=80, Caption="Mode :")
CWho = CreateComponent("TCheckBox", f)
CWho.SetProps(Parent=f, Left=30, Top=90, Width=80, Caption="Tiers :")
CNfo = CreateComponent("TCheckBox", f)
CNfo.SetProps(Parent=f, Left=30, Top=120, Width=80, Caption="Dtails :")
CCtg = CreateComponent("TCheckBox", f)
CCtg.SetProps(Parent=f, Left=30, Top=150, Width=80, Caption="Catgorie :")
CVal = CreateComponent("TCheckBox", f)
CVal.SetProps(Parent=f, Left=30, Top=180, Width=80, Caption="Montant :")
CMrk = CreateComponent("TCheckBox", f)
CMrk.SetProps(Parent=f, Left=30, Top=210, Width=80, Caption="Pointage :")
EDte = CreateComponent("TDateTimePicker", f)
EDte.SetProps(Parent=f, Left=130, Top=30, Width=180, Height=20, Format="ddd d MMMM yyyy")
EMod = CreateComponent("TComboBox", f)
EMod.SetProps(Parent=f, Left=130, Top=60, Width=180, Style="csDropDownList")
EMod.Items.Text = "\n".join(modes)
EMod.ItemIndex = 0
EWho = CreateComponent("TEdit", f)
EWho.SetProps(Parent=f, Left=130, Top=90, Width=180, Text="")
ENfo = CreateComponent("TEdit", f)
ENfo.SetProps(Parent=f, Left=130, Top=120, Width=180, Text="")
ECtg = CreateComponent("TComboBox", f)
ECtg.SetProps(Parent=f, Left=130, Top=150, Width=180, Style="csDropDownList")
ECtg.Items.Text = "\n".join(CNames)
ECtg.ItemIndex = 0
EVal = CreateComponent("TEdit", f)
EVal.SetProps(Parent=f, Left=130, Top=180, Width=180, Text="")
EMrk = CreateComponent("TComboBox", f)
EMrk.SetProps(Parent=f, Left=130, Top=210, Width=180, Style="csDropDownList")
EMrk.Items.Text = "Non point\nPoint\nRapproch"
EMrk.ItemIndex = 0
BCnl = CreateComponent("TButton", f)
BCnl.SetProps(Parent=f, Left=80, Top=264, Width=90, Height=25, Caption="Annuler", Cancel=1, Modalresult=2)
BOK = CreateComponent("TButton", f)
BOK.SetProps(Parent=f, Left=176, Top=264, Width=90, Height=25, Caption="OK", Default=1, OnClick=Apply)

f.ShowModal()